Attribute VB_Name = "Module1"
Option Explicit

Public Const SERVICES_ACTIVE_DATABASE = "ServicesActive"
Public Const SERVICE_CONTROL_STOP = &H1
Public Const SERVICE_CONTROL_PAUSE = &H2
Public Const STANDARD_RIGHTS_REQUIRED = &HF0000
Public Const SC_MANAGER_CONNECT = &H1
Public Const SC_MANAGER_CREATE_SERVICE = &H2
Public Const SC_MANAGER_ENUMERATE_SERVICE = &H4
Public Const SC_MANAGER_LOCK = &H8
Public Const SC_MANAGER_QUERY_LOCK_STATUS = &H10
Public Const SC_MANAGER_MODIFY_BOOT_CONFIG = &H20
Public Const SC_MANAGER_ALL_ACCESS = (STANDARD_RIGHTS_REQUIRED Or SC_MANAGER_CONNECT Or SC_MANAGER_CREATE_SERVICE Or SC_MANAGER_ENUMERATE_SERVICE Or SC_MANAGER_LOCK Or SC_MANAGER_QUERY_LOCK_STATUS Or SC_MANAGER_MODIFY_BOOT_CONFIG)
Public Const SERVICE_QUERY_CONFIG = &H1
Public Const SERVICE_ACTIVE = &H1
Public Const SERVICE_CHANGE_CONFIG = &H2
Public Const SERVICE_QUERY_STATUS = &H4
Public Const SERVICE_ENUMERATE_DEPENDENTS = &H8
Public Const SERVICE_START = &H10
Public Const SERVICE_STOP = &H20
Public Const SERVICE_PAUSE_CONTINUE = &H40
Public Const SERVICE_INTERROGATE = &H80
Public Const SERVICE_USER_DEFINED_CONTROL = &H100
Public Const SERVICE_ALL_ACCESS = (STANDARD_RIGHTS_REQUIRED Or SERVICE_QUERY_CONFIG Or SERVICE_CHANGE_CONFIG Or SERVICE_QUERY_STATUS Or SERVICE_ENUMERATE_DEPENDENTS Or SERVICE_START Or SERVICE_STOP Or SERVICE_PAUSE_CONTINUE Or SERVICE_INTERROGATE Or SERVICE_USER_DEFINED_CONTROL)
Public Const GENERIC_READ = &H80000000
Public Const ERROR_INSUFFICIENT_BUFFER = 122

Public Const ERROR_MORE_DATA = 234
Public Const SERVICE_INACTIVE = &H2

'   dwServiceType
Public Const SERVICE_WIN32_OWN_PROCESS As Long = &H10
Public Const SERVICE_WIN32_SHARE_PROCESS As Long = &H20
Public Const SERVICE_WIN32 As Long = SERVICE_WIN32_OWN_PROCESS _
                  + SERVICE_WIN32_SHARE_PROCESS
                  
'  dwCurrentState
Public Const SERVICE_STOPPED = &H1
Public Const SERVICE_START_PENDING = &H2
Public Const SERVICE_STOP_PENDING = &H3
Public Const SERVICE_RUNNING = &H4
Public Const SERVICE_CONTINUE_PENDING = &H5
Public Const SERVICE_PAUSE_PENDING = &H6
Public Const SERVICE_PAUSED = &H7

'  dwControlsAccepted
Public Const SERVICE_ACCEPT_STOP = &H1
Public Const SERVICE_ACCEPT_PAUSE_CONTINUE = &H2
Public Const SERVICE_ACCEPT_SHUTDOWN = &H4

Type SERVICE_STATUS
    dwServiceType As Long
    dwCurrentState As Long
    dwControlsAccepted As Long
    dwWin32ExitCode As Long
    dwServiceSpecificExitCode As Long
    dwCheckPoint As Long
    dwWaitHint As Long
End Type

Type QUERY_SERVICE_CONFIG
      dwServiceType As Long
      dwStartType As Long
      dwErrorControl As Long
      lpBinaryPathName As Long 'String
      lpLoadOrderGroup As Long ' String
      dwTagId As Long
      lpDependencies As Long 'String
      lpServiceStartName As Long 'String
      lpDisplayName As Long  'String
End Type
   
Type ENUM_SERVICE_STATUS
         lpServiceName As Long
         lpDisplayName As Long
         ServiceStatus As SERVICE_STATUS
End Type

Declare Function OpenSCManager Lib "advapi32.dll" Alias "OpenSCManagerA" ( _
          ByVal lpMachineName As String, _
          ByVal lpDatabaseName As String, _
          ByVal dwDesiredAccess As Long) As Long
          
Declare Function OpenService Lib "advapi32.dll" Alias "OpenServiceA" ( _
          ByVal hSCManager As Long, _
          ByVal lpServiceName As String, _
          ByVal dwDesiredAccess As Long) As Long

Declare Function CloseServiceHandle Lib "advapi32.dll" ( _
          ByVal hSCObject As Long) As Long
         
Declare Function QueryServiceStatus Lib "advapi32.dll" ( _
          ByVal hService As Long, _
          lpServiceStatus As SERVICE_STATUS) As Long
          
Declare Function ControlService Lib "advapi32.dll" ( _
          ByVal hService As Long, _
          ByVal dwControl As Long, _
          lpServiceStatus As SERVICE_STATUS) As Long

Declare Function StartService Lib "advapi32.dll" Alias "StartServiceA" ( _
          ByVal hService As Long, _
          ByVal dwNumServiceArgs As Long, _
          ByVal lpServiceArgVectors As Long) As Long
          
Declare Function QueryServiceConfig Lib "advapi32.dll" Alias "QueryServiceConfigA" _
      (ByVal hService As Long, _
      lpServiceConfig As Byte, _
      ByVal cbBufSize As Long, _
      pcbBytesNeeded As Long) As Long
      
Public Declare Function EnumServicesStatus Lib "advapi32.dll" Alias "EnumServicesStatusA" ( _
          ByVal hSCManager As Long, _
          ByVal dwServiceType As Long, _
          ByVal dwServiceState As Long, _
          lpServices As Any, _
          ByVal cbBufSize As Long, _
          pcbBytesNeeded As Long, _
          lpServicesReturned As Long, _
          lpResumeHandle As Long) As Long
      
Declare Sub CopyMemory Lib "KERNEL32" Alias "RtlMoveMemory" _
      (hpvDest As Any, _
      hpvSource As Any, _
      ByVal cbCopy As Long)

Declare Function lstrcpy Lib "KERNEL32" Alias "lstrcpyA" _
      (ByVal lpString1 As String, _
      ByVal lpString2 As Long) As Long
      
Public Function ServiceStatus(ComputerName As String, ServiceName As String) As String
    Dim ServiceStat As SERVICE_STATUS
    Dim hSManager As Long
    Dim hService As Long
    Dim hServiceStatus As Long

    ServiceStatus = ""
    hSManager = OpenSCManager(ComputerName, SERVICES_ACTIVE_DATABASE, SC_MANAGER_ALL_ACCESS)
    If hSManager <> 0 Then
        hService = OpenService(hSManager, ServiceName, SERVICE_ALL_ACCESS)
        If hService <> 0 Then
            hServiceStatus = QueryServiceStatus(hService, ServiceStat)
            If hServiceStatus <> 0 Then
                Select Case ServiceStat.dwCurrentState
                Case SERVICE_STOPPED
                    ServiceStatus = "Stopped"
                Case SERVICE_START_PENDING
                    ServiceStatus = "Start Pending"
                Case SERVICE_STOP_PENDING
                    ServiceStatus = "Stop Pending"
                Case SERVICE_RUNNING
                    ServiceStatus = "Running"
                Case SERVICE_CONTINUE_PENDING
                    ServiceStatus = "Coninue Pending"
                Case SERVICE_PAUSE_PENDING
                    ServiceStatus = "Pause Pending"
                Case SERVICE_PAUSED
                    ServiceStatus = "Paused"
                End Select
            End If
            CloseServiceHandle hService
        End If
        CloseServiceHandle hSManager
    End If
End Function

Public Sub ServicePause(ComputerName As String, ServiceName As String)
    Dim ServiceStatus As SERVICE_STATUS
    Dim hSManager As Long
    Dim hService As Long
    Dim res As Long

    hSManager = OpenSCManager(ComputerName, SERVICES_ACTIVE_DATABASE, SC_MANAGER_ALL_ACCESS)
    If hSManager <> 0 Then
        hService = OpenService(hSManager, ServiceName, SERVICE_ALL_ACCESS)
        If hService <> 0 Then
            res = ControlService(hService, SERVICE_CONTROL_PAUSE, ServiceStatus)
            CloseServiceHandle hService
        End If
        CloseServiceHandle hSManager
    End If
End Sub

Public Sub ServiceStart(ComputerName As String, ServiceName As String)
    Dim ServiceStatus As SERVICE_STATUS
    Dim hSManager As Long
    Dim hService As Long
    Dim res As Long

    hSManager = OpenSCManager(ComputerName, SERVICES_ACTIVE_DATABASE, SC_MANAGER_ALL_ACCESS)
    If hSManager <> 0 Then
        hService = OpenService(hSManager, ServiceName, SERVICE_ALL_ACCESS)
        If hService <> 0 Then
            res = StartService(hService, 0, 0)
            CloseServiceHandle hService
        End If
        CloseServiceHandle hSManager
    End If
End Sub

Public Sub ServiceStop(ComputerName As String, ServiceName As String)
    Dim ServiceStatus As SERVICE_STATUS
    Dim hSManager As Long
    Dim hService As Long
    Dim res As Long

    hSManager = OpenSCManager(ComputerName, SERVICES_ACTIVE_DATABASE, SC_MANAGER_ALL_ACCESS)
    If hSManager <> 0 Then
        hService = OpenService(hSManager, ServiceName, SERVICE_ALL_ACCESS)
        If hService <> 0 Then
            res = ControlService(hService, SERVICE_CONTROL_STOP, ServiceStatus)
            CloseServiceHandle hService
        End If
        CloseServiceHandle hSManager
    End If
End Sub

Public Sub GetServiceInfo(lngServiceType As Long)
         Dim hSCM As Long
         Dim lpEnumServiceStatus() As ENUM_SERVICE_STATUS
         Dim lngServiceStatusInfoBuffer As Long
         Dim strServiceName As String * 250
         Dim lngBytesNeeded As Long
         Dim lngServicesReturned As Long
         Dim hNextUnreadEntry As Long
         Dim lngStructsNeeded As Long
         Dim lngResult As Long
         Dim i As Long

         'Open connection to Service Control Manager.
         hSCM = OpenSCManager(vbNullString, vbNullString, _
                              SC_MANAGER_ENUMERATE_SERVICE)

         If hSCM = 0 Then
            MsgBox "OpenSCManager failed. LastDllError = " _
            & CStr(Err.LastDllError)
            Exit Sub
         End If

         'Get buffer size (bytes) without passing a buffer
         'and make sure starts at 0th entry.
         hNextUnreadEntry = 0
         lngResult = EnumServicesStatus(hSCM, _
                                        SERVICE_WIN32, _
                                        lngServiceType, _
                                        ByVal &H0, _
                                        &H0, _
                                        lngBytesNeeded, _
                                        lngServicesReturned, _
                                        hNextUnreadEntry)

         'We should receive MORE_DATA error.
         If Not Err.LastDllError = ERROR_MORE_DATA Then
            MsgBox "LastDLLError = " & CStr(Err.LastDllError)
            Exit Sub
         End If

         'Calculate the number of structures needed.
         lngStructsNeeded = _
         lngBytesNeeded / Len(lpEnumServiceStatus(0)) + 1

         'Redimension the array according to our calculation.
         ReDim lpEnumServiceStatus(lngStructsNeeded - 1)

         'Get buffer size in bytes.
         lngServiceStatusInfoBuffer = _
            lngStructsNeeded * Len(lpEnumServiceStatus(0))

         'Get services information starting entry 0.
         hNextUnreadEntry = 0
         lngResult = EnumServicesStatus(hSCM, _
                                       SERVICE_WIN32, _
                                       lngServiceType, _
                                       lpEnumServiceStatus(0), _
                                       lngServiceStatusInfoBuffer, _
                                       lngBytesNeeded, _
                                       lngServicesReturned, _
                                       hNextUnreadEntry)

         If lngResult = 0 Then
            MsgBox "EnumServicesStatus failed. LastDllError = " _
               & CStr(Err.LastDllError)
            Exit Sub
         End If


         'Get the strings and display them.
         With Form1
            .List1.Clear
            .List1.AddItem "Display Names"
            .List2.Clear
            .List2.AddItem "Service Names"
            For i = 0 To lngServicesReturned - 1
               lngResult = lstrcpy(ByVal strServiceName, _
                  ByVal lpEnumServiceStatus(i).lpDisplayName)
               .List1.AddItem strServiceName
               lngResult = lstrcpy(ByVal strServiceName, _
                  ByVal lpEnumServiceStatus(i).lpServiceName)
               .List2.AddItem strServiceName
            Next
         End With

         'Clean up.
         CloseServiceHandle (hSCM)

      End Sub

